<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        // Migrate supporters
        DB::table('users')->where('is_patreon', 1)->update([
            'roles' => DB::raw("JSON_ARRAY('supporter')"),
        ]);

        // Migrate banned
        DB::table('users')->where('is_banned', 1)->update([
            'roles' => DB::raw("JSON_ARRAY('banned')"),
        ]);

        // Migrate admins
        DB::table('users')->where('is_admin', 1)->update([
            'roles' => DB::raw("JSON_ARRAY('admin')"),
        ]);

        // Drop columns
        Schema::table('users', function (Blueprint $table) {
            $table->dropColumn('is_admin');
            $table->dropColumn('is_patreon');
            $table->dropColumn('is_banned');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        DB::table('users')->update(['roles' => null]);
        Schema::table('users', function (Blueprint $table) {
            $table->boolean('is_admin')->default(0);
            $table->boolean('is_patreon')->default(0);
            $table->boolean('is_banned')->default(0);
        });
    }
};
